wxWidgets: wxArchiveClassFactory Class Reference

| Version: 3.2.5

Public Member Functions | Static Public Member Functions | List of all members
wxArchiveClassFactory Class Referenceabstract
Class List by Category » Archive support | Class List by Category » Streams

`#include <wx/archive.h>`

Inheritance diagram for wxArchiveClassFactory:
[legend]

## Detailed Description

Allows the creation of streams to handle archive formats such as zip and tar.

For example, given a filename you can search for a factory that will handle it and create a stream to read it:

factory = wxArchiveClassFactory::Find(filename, wxSTREAM_FILEEXT);
if (factory)
stream = factory->NewStream(new wxFFileInputStream(filename));
wxArchiveClassFactory::Find
static const wxArchiveClassFactory * Find(const wxString &protocol, wxStreamProtocolType type=wxSTREAM_PROTOCOL)
A static member that finds a factory that can handle a given protocol, MIME type or file extension.
wxFFileInputStream
This class represents data read in from a file.
Definition: wfstream.h:284
wxSTREAM_FILEEXT
@ wxSTREAM_FILEEXT
File extensions the stream handles.
Definition: stream.h:826

wxArchiveClassFactory::Find can also search for a factory by MIME type or wxFileSystem protocol.

The available factories can be enumerated using wxArchiveClassFactory::GetFirst() and wxArchiveClassFactory::GetNext().

##

Library: wxBase
Category: Archive support, Streams

See also
  Archive Formats, Generic Archive Programming, wxArchiveEntry, wxArchiveInputStream, wxArchiveOutputStream, wxFilterClassFactory

const wxArchiveClassFactory * | GetNext () const
| GetFirst and GetNext can be used to enumerate the available factories. More...
static const wxArchiveClassFactory * | GetFirst ()
| GetFirst and GetNext can be used to enumerate the available factories. More...

## Public Member Functions
bool | CanHandle (const wxString &protocol, wxStreamProtocolType type=wxSTREAM_PROTOCOL) const
| Returns true if this factory can handle the given protocol, MIME type or file extension. More...
wxMBConv & | GetConv () const
| Returns the wxMBConv object that the created streams will use when translating meta-data. More...
void | SetConv (wxMBConv &conv)
| Sets the wxMBConv object that the created streams will use when translating meta-data. More...
virtual wxString | GetInternalName (const wxString &name, wxPathFormat format=wxPATH_NATIVE) const =0
| Calls the static GetInternalName() function for the archive entry type, for example wxZipEntry::GetInternalName. More...
wxString | GetProtocol () const
| Returns the wxFileSystem protocol supported by this factory. More...
virtual const wxChar ** | GetProtocols (wxStreamProtocolType type=wxSTREAM_PROTOCOL) const =0
| Returns the protocols, MIME types or file extensions supported by this factory, as an array of null terminated strings. More...
wxArchiveEntry * | NewEntry () const
| Create a new wxArchiveEntry object of the appropriate type. More...
void | PushFront ()
| Adds this class factory to the list returned by GetFirst() or GetNext(). More...
void | Remove ()
| Removes this class factory from the list returned by GetFirst() and GetNext(). More...
wxArchiveInputStream * | NewStream (wxInputStream &stream) const
| Create a new input or output stream to read or write an archive. More...
wxArchiveOutputStream * | NewStream (wxOutputStream &stream) const
| Create a new input or output stream to read or write an archive. More...
wxArchiveInputStream * | NewStream (wxInputStream *stream) const
| Create a new input or output stream to read or write an archive. More...
wxArchiveOutputStream * | NewStream (wxOutputStream *stream) const
| Create a new input or output stream to read or write an archive. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Static Public Member Functions
static const wxArchiveClassFactory * | Find (const wxString &protocol, wxStreamProtocolType type=wxSTREAM_PROTOCOL)
| A static member that finds a factory that can handle a given protocol, MIME type or file extension. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Member Function Documentation

## ◆ CanHandle()

bool wxArchiveClassFactory::CanHandle | ( | const wxString & | protocol,
|  | wxStreamProtocolType | type = `wxSTREAM_PROTOCOL`
| ) |  | const

Returns true if this factory can handle the given protocol, MIME type or file extension.

When using wxSTREAM_FILEEXT for the second parameter, the first parameter can be a complete filename rather than just an extension.

## ◆ Find()

static const wxArchiveClassFactory* wxArchiveClassFactory::Find | ( | const wxString & | protocol,
|  | wxStreamProtocolType | type = `wxSTREAM_PROTOCOL`
| ) |  |
| static

A static member that finds a factory that can handle a given protocol, MIME type or file extension.

Returns a pointer to the class factory if found, or NULL otherwise. It does not give away ownership of the factory.

When using wxSTREAM_FILEEXT for the second parameter, the first parameter can be a complete filename rather than just an extension.

## ◆ GetConv()

wxMBConv& wxArchiveClassFactory::GetConv | ( |  | ) | const

Returns the wxMBConv object that the created streams will use when translating meta-data.

The initial default, set by the constructor, is wxConvLocal.

## ◆ GetFirst()

static const wxArchiveClassFactory* wxArchiveClassFactory::GetFirst | ( |  | ) |
| static

GetFirst and GetNext can be used to enumerate the available factories.

For example, to list them:

wxString list;
const wxArchiveClassFactory *factory = wxArchiveClassFactory::GetFirst();
while (factory) {
list << factory->GetProtocol() << wxT("\n");
factory = factory->GetNext();
}
wxArchiveClassFactory
Allows the creation of streams to handle archive formats such as zip and tar.
Definition: archive.h:330
wxArchiveClassFactory::GetProtocol
wxString GetProtocol() const
Returns the wxFileSystem protocol supported by this factory.
wxArchiveClassFactory::GetFirst
static const wxArchiveClassFactory * GetFirst()
GetFirst and GetNext can be used to enumerate the available factories.
wxArchiveClassFactory::GetNext
const wxArchiveClassFactory * GetNext() const
GetFirst and GetNext can be used to enumerate the available factories.
wxString
String class for passing textual data to or receiving it from wxWidgets.
Definition: string.h:315
wxT
#define wxT(string)
This macro can be used with character and string literals (in other words, 'x' or "foo") to automatic...
Definition: chartype.h:32

GetFirst() and GetNext() return a pointer to a factory or NULL if no more are available. They do not give away ownership of the factory.

## ◆ GetInternalName()

virtual wxString wxArchiveClassFactory::GetInternalName | ( | const wxString & | name,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  | const
| pure virtual

Calls the static GetInternalName() function for the archive entry type, for example wxZipEntry::GetInternalName.

## ◆ GetNext()

const wxArchiveClassFactory* wxArchiveClassFactory::GetNext | ( |  | ) | const

GetFirst and GetNext can be used to enumerate the available factories.

For example, to list them:

wxString list;
const wxArchiveClassFactory *factory = wxArchiveClassFactory::GetFirst();
while (factory) {
list << factory->GetProtocol() << wxT("\n");
factory = factory->GetNext();
}

GetFirst() and GetNext() return a pointer to a factory or NULL if no more are available. They do not give away ownership of the factory.

## ◆ GetProtocol()

wxString wxArchiveClassFactory::GetProtocol | ( |  | ) | const

Returns the wxFileSystem protocol supported by this factory.

Equivalent to

wxString(*GetProtocols())
wxArchiveClassFactory::GetProtocols
virtual const wxChar ** GetProtocols(wxStreamProtocolType type=wxSTREAM_PROTOCOL) const =0
Returns the protocols, MIME types or file extensions supported by this factory, as an array of null t...

.

## ◆ GetProtocols()

virtual const wxChar** wxArchiveClassFactory::GetProtocols | ( | wxStreamProtocolType | type = `wxSTREAM_PROTOCOL` | ) | const
| pure virtual

Returns the protocols, MIME types or file extensions supported by this factory, as an array of null terminated strings.

It does not give away ownership of the array or strings. For example, to list the file extensions a factory supports:

wxString list;
const wxChar *const *p;
for (p = factory->GetProtocols(wxSTREAM_FILEEXT); *p; p++)
list << *p << wxT("\n");
wxChar
wxUSE_UNICODE_dependent wxChar
wxChar is defined to be - char when wxUSE_UNICODE==0 - wchar_t when wxUSE_UNICODE==1 (the default).
Definition: chartype.h:105

## ◆ NewEntry()

wxArchiveEntry* wxArchiveClassFactory::NewEntry | ( |  | ) | const

Create a new wxArchiveEntry object of the appropriate type.

## ◆ NewStream() [1/4]

wxArchiveInputStream* wxArchiveClassFactory::NewStream | ( | wxInputStream & | stream | ) | const

Create a new input or output stream to read or write an archive.

If the parent stream is passed as a pointer then the new archive stream takes ownership of it. If it is passed by reference then it does not.

## ◆ NewStream() [2/4]

wxArchiveInputStream* wxArchiveClassFactory::NewStream | ( | wxInputStream * | stream | ) | const

Create a new input or output stream to read or write an archive.

If the parent stream is passed as a pointer then the new archive stream takes ownership of it. If it is passed by reference then it does not.

## ◆ NewStream() [3/4]

wxArchiveOutputStream* wxArchiveClassFactory::NewStream | ( | wxOutputStream & | stream | ) | const

Create a new input or output stream to read or write an archive.

If the parent stream is passed as a pointer then the new archive stream takes ownership of it. If it is passed by reference then it does not.

## ◆ NewStream() [4/4]

wxArchiveOutputStream* wxArchiveClassFactory::NewStream | ( | wxOutputStream * | stream | ) | const

Create a new input or output stream to read or write an archive.

If the parent stream is passed as a pointer then the new archive stream takes ownership of it. If it is passed by reference then it does not.

## ◆ PushFront()

void wxArchiveClassFactory::PushFront | ( |  | ) |

Adds this class factory to the list returned by GetFirst() or GetNext().

It is not necessary to do this to use the archive streams. It is usually used when implementing streams, typically the implementation will add a static instance of its factory class.

It can also be used to change the order of a factory already in the list, bringing it to the front. This isn't a thread safe operation so can't be done when other threads are running that will be using the list. The list does not take ownership of the factory.

## ◆ Remove()

void wxArchiveClassFactory::Remove | ( |  | ) |

Removes this class factory from the list returned by GetFirst() and GetNext().

Removing from the list isn't a thread safe operation so can't be done when other threads are running that will be using the list. The list does not own the factories, so removing a factory does not delete it.

## ◆ SetConv()

void wxArchiveClassFactory::SetConv | ( | wxMBConv & | conv | ) |

Sets the wxMBConv object that the created streams will use when translating meta-data.